---
- name: Set default facts for K8S
  ansible.builtin.set_fact:
    k8s_config: "{{ K8S_KUBECONFIG_PATH }}/{{ inv_op_stack.ns_kubeconfig }}"
    k8s_context: "{{ inv_k8s.config.context }}"
    k8s_namespace: "{{ inv_op_stack.cert_manager_operator.ns_name }}"

- name: "[Helm] Create the Cert-Manager Installation"
  include_tasks: ansible-templates/k8s_tasks/k8s-helm.yml
  vars:
    helm_repo_name: "{{ op_cert_manager_operator.helm_repo_name }}"
    helm_repo_url: "{{ op_cert_manager_operator.helm_repo_url }}"
    helm_chart_name: "{{ op_cert_manager_operator.helm_chart_name }}"
    helm_release_name: "{{ op_cert_manager_operator.helm_release_name }}"
    helm_chart_reference: "{{ helm_repo_name }}/{{ helm_chart_name }}"
    helm_chart_version: "{{ op_cert_manager_operator.helm_chart_version }}"
    helm_values_file: "00_op_cert_manager_operator/cert-manager-operator-values.yaml.j2"
    helm_create_namespace: "{{ inv_op_stack.ns_create }}"

# - name: Add Jetstack Repo
#   kubernetes.core.helm_repository:
#     repo_name: "{{ op_cert_manager_operator.helm_repo_name }}"
#     repo_url: "{{ op_cert_manager_operator.helm_repo_url }}"

# - name: Deploy stable version of cert-manager chart
#   kubernetes.core.helm:
#     name: "{{ op_cert_manager_operator.helm_release_name }}"
#     chart_ref: "{{ op_cert_manager_operator.helm_repo_name }}/{{ op_cert_manager_operator.helm_chart_name }}"
#     kubeconfig: "{{ k8s_config }}"
#     context: "{{ k8s_context }}"
#     release_namespace: "{{ k8s_namespace }}"
#     update_repo_cache: true
#     create_namespace: "{{ inv_op_stack.ns_create }}"
#     values: "{{ lookup('template', '00_op_cert_manager_operator/cert-manager-operator-values.yaml.j2') | from_yaml }}"

- name: Create LE Staging Issuer
  kubernetes.core.k8s:
    definition: "{{ item }}"
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    namespace: "{{ k8s_namespace }}"
    state: present
  loop:
    - "{{ lookup('template', '00_op_cert_manager_operator/staging_issuer.yml') | from_yaml }}"

- name: Create LE Production Issuer
  kubernetes.core.k8s:
    definition: "{{ item }}"
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    namespace: "{{ k8s_namespace }}"
    state: present
  loop:
    - "{{ lookup('template', '00_op_cert_manager_operator/production_issuer.yml') | from_yaml }}"
